using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TheLandBeforeDataBinding
{
    public partial class BindingSourceForm : Form
    {
        List<RaceCarDriverNotify> drivers = new List<RaceCarDriverNotify>();

        BindingSource driversBS = new BindingSource();

        BindingManagerBase BindingManager
        {
            get { return this.BindingContext[this.driversBS]; }
        }

        public BindingSourceForm()
        {
            InitializeComponent();

            this.driversBS.DataSource = drivers.GetType();

            driversBS.Add(new RaceCarDriverNotify("M Schumacher", 500));
            driversBS.Add(new RaceCarDriverNotify("A Senna", 1000));
            driversBS.Add(new RaceCarDriverNotify("A Prost", 400));
            
            this.textBoxName.DataBindings.Add(
                "Text", driversBS, "Name");
            this.textBoxWins.DataBindings.Add(
                            "Text", driversBS, "Wins");

            RefreshItems();
        }



        void RefreshItems()
        {
            int count = this.BindingManager.Count;
            int pos = this.BindingManager.Position + 1;

            this.labelCount.Text = count.ToString();
            this.labelPosition.Text = pos.ToString();

            this.buttonFirst.Enabled = (pos > 1);
            this.buttonPrev.Enabled = (pos > 1);
            this.buttonNext.Enabled = (pos < count);
            this.buttonLast.Enabled = (pos < count);
        }
        private void buttonFirst_Click(object sender, EventArgs e)
        {
            this.BindingManager.Position = 0;
            RefreshItems();
        }

        private void buttonPrev_Click(object sender, EventArgs e)
        {
            --this.BindingManager.Position;
            RefreshItems();
        }

        private void buttonNext_Click(object sender, EventArgs e)
        {
            ++this.BindingManager.Position;
            RefreshItems();
        }

        private void buttonLast_Click(object sender, EventArgs e)
        {
            this.BindingManager.Position = this.BindingManager.Count - 1;
            RefreshItems();
        }

        private void buttonAddWin_Click(object sender, EventArgs e)
        {
            int current = this.BindingManager.Position;
            ++((RaceCarDriverNotify)driversBS[current]).Wins;
        }

        private void buttonShowData_Click(object sender, EventArgs e)
        {
            MessageBox.Show(driversBS[this.BindingManager.Position].ToString());
        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            driversBS.Add(new RaceCarDriverNotify("F Flintstone", 1));
            RefreshItems();
        }
    }
}